﻿using MvcApplication1.Models;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MvcApplication1.Controllers
{
    public class HomeController : Controller
    {
        private List<Category> Categories { get; set; }

        public HomeController()
        {
            Categories = new List<Category>();

            var beverages = new List<Product>()
            {
                new Product(1, 1, "Coca cola"),
                new Product(1, 2, "Pepsi"),
                new Product(1, 3, "Fanta"),
                new Product(1, 4, "Nestea"),
            };

            var beveragesCategory = new Category(1, "Beverages", "Soft drinks, coffees, teas, beers and ales", beverages);
            Categories.Add(beveragesCategory);

            var producibles = new List<Product>()
            {
                new Product(2, 5, "Uncle Bob's Organic Dried Pears"),
                new Product(2, 6, "Tofu"),
                new Product(2, 7, "Manjimup Dried Apples"),
                new Product(2, 8, "Longlife Tofu"),
            };

            var producedCategory = new Category(2, "Produce", "Dried food and bean curd", producibles);
            Categories.Add(producedCategory);

            var seaFood = new List<Product>()
            {
                new Product(3, 9, "Salmon"),
                new Product(3, 10, "Tuna"),
                new Product(3, 11, "Nori"),
                new Product(3, 12, "Oysters"),
            };

            var seaFoodCategory = new Category(3, "Sea Food", "Seaweed and fish", seaFood);
            Categories.Add(seaFoodCategory);
        }


        public ActionResult Index()
        {
            return View(Categories);
        }

        public ActionResult GetData()
        {
            var json = Json(new
            {
                success = true,
                categories = JsonConvert.SerializeObject(Categories),
            });
            json.JsonRequestBehavior = JsonRequestBehavior.AllowGet;

            return json;
        }

        public ActionResult GetNewData()
        {
            Categories[0].Name += " NEW";
            Categories[1].Name += " NEW";
            Categories[0].Products[0].Name += " NEW";
            Categories[1].Products[1].Name += " NEW";
            var json = Json(new
            {
                success = true,
                categories = JsonConvert.SerializeObject(Categories)
            });

            //json.JsonRequestBehavior=JsonRequestBehavior.AllowGet;

            return json;
        }

    }
}
